package net.codinux.banking.epcqrcode

import com.soywiz.korim.bitmap.Bitmap32


open class EpcQrCode(
  open val bitmap: Bitmap32,
  open val bytes: ByteArray,
  heightAndWidth: Int
) {

  companion object {

    const val DefaultHeightAndWidth = 500

  }


  open val height: Int = heightAndWidth

  open val width: Int = heightAndWidth


  open fun qrCodeAsString(border: Int = 0, invertColors: Boolean = false): String {
    return EpcQrCodeStringFormatter().asString(this, border, invertColors)
  }

  open fun qrCodeAsSmallString(border: Int = 0, invertColors: Boolean = false): String {
    return EpcQrCodeStringFormatter().asSmallString(this, border, invertColors)
  }


  /**
   * black = -1, white = -16777216
   */
  open fun getColorCodeAt(x: Int, y: Int): Int {
    return bitmap.getInt(x, y)
  }

}